soubin 7 лет назад
Родитель
Сommit
3e25659866

+ 25
- 0
.gitignore Просмотреть файл

@@ -0,0 +1,25 @@
1
+/target/
2
+!.mvn/wrapper/maven-wrapper.jar
3
+
4
+### STS ###
5
+.apt_generated
6
+.classpath
7
+.factorypath
8
+.project
9
+.settings
10
+.springBeans
11
+.sts4-cache
12
+
13
+### IntelliJ IDEA ###
14
+.idea
15
+*.iws
16
+*.iml
17
+*.ipr
18
+
19
+### NetBeans ###
20
+/nbproject/private/
21
+/nbbuild/
22
+/dist/
23
+/nbdist/
24
+/.nb-gradle/
25
+/build/

Двоичные данные
.mvn/wrapper/maven-wrapper.jar Просмотреть файл


+ 1
- 0
.mvn/wrapper/maven-wrapper.properties Просмотреть файл

@@ -0,0 +1 @@
1
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.6.0/apache-maven-3.6.0-bin.zip

+ 32
- 1
README.md Просмотреть файл

@@ -1,4 +1,35 @@
1 1
 # spring-boot-jpa
2 2
 
3 3
 spring boot 2
4
-JPA相关的代码
4
+JPA相关的代码
5
+
6
+结果
7
+1. insert 无主键
8
+{"ex":{"exClass":"org.springframework.orm.jpa.JpaSystemException","message":"ids for this class must be manually assigned before calling save(): ltass.staudy.spring.data.jpa.entity.User; nested exception is org.hibernate.id.IdentifierGenerationException: ids for this class must be manually assigned before calling save(): ltass.staudy.spring.data.jpa.entity.User"},"exCause":{"causeBy":"org.hibernate.id.IdentifierGenerationException","message":"ids for this class must be manually assigned before calling save(): ltass.staudy.spring.data.jpa.entity.User"}}
9
+
10
+2. insert 非空字段未设定
11
+{"ex":{"exClass":"org.springframework.dao.DataIntegrityViolationException","message":"could not execute statement; SQL [n/a]; constraint [null]; nested exception is org.hibernate.exception.ConstraintViolationException: could not execute statement"},"exCause":{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}}
12
+
13
+3. insert 字段长度越界
14
+{"ex":{"exClass":"org.springframework.dao.DataIntegrityViolationException","message":"could not execute statement; SQL [n/a]; nested exception is org.hibernate.exception.DataException: could not execute statement"},"exCause":{"causeBy":"org.hibernate.exception.DataException","message":"could not execute statement"}}
15
+
16
+4.insert 主键冲突
17
+{"ex":{"exClass":"org.springframework.dao.DataIntegrityViolationException","message":"could not execute statement; SQL [n/a]; constraint [PRIMARY]; nested exception is org.hibernate.exception.ConstraintViolationException: could not execute statement"},"exCause":{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}}
18
+
19
+5.insert 唯一索引冲突
20
+{"ex":{"exClass":"org.springframework.dao.DataIntegrityViolationException","message":"could not execute statement; SQL [n/a]; constraint [PRIMARY]; nested exception is org.hibernate.exception.ConstraintViolationException: could not execute statement"},"exCause":{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}}
21
+
22
+6. update 无主键
23
+{"ex":{"exClass":"org.springframework.orm.jpa.JpaSystemException","message":"ids for this class must be manually assigned before calling save(): ltass.staudy.spring.data.jpa.entity.User; nested exception is org.hibernate.id.IdentifierGenerationException: ids for this class must be manually assigned before calling save(): ltass.staudy.spring.data.jpa.entity.User"},"exCause":{"causeBy":"org.hibernate.id.IdentifierGenerationException","message":"ids for this class must be manually assigned before calling save(): ltass.staudy.spring.data.jpa.entity.User"}}
24
+
25
+7 update 非空字段未设定
26
+{"ex":{"exClass":"org.springframework.dao.DataIntegrityViolationException","message":"could not execute statement; SQL [n/a]; constraint [null]; nested exception is org.hibernate.exception.ConstraintViolationException: could not execute statement"},"exCause":{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}}
27
+
28
+8. update 字段长度越界
29
+"ex":{"exClass":"org.springframework.dao.DataIntegrityViolationException","message":"could not execute statement; SQL [n/a]; nested exception is org.hibernate.exception.DataException: could not execute statement"},"exCause":{"causeBy":"org.hibernate.exception.DataException","message":"could not execute statement"}}
30
+
31
+9. update 乐观锁冲突 即 Version冲突
32
+{"ex":{"exClass":"org.springframework.orm.ObjectOptimisticLockingFailureException","message":"Object of class [ltass.staudy.spring.data.jpa.entity.User] with identifier [1]: optimistic locking failed; nested exception is org.hibernate.StaleObjectStateException: Row was updated or deleted by another transaction (or unsaved-value mapping was incorrect) : [ltass.staudy.spring.data.jpa.entity.User#1]"},"exCause":{"causeBy":"org.hibernate.StaleObjectStateException","message":"Row was updated or deleted by another transaction (or unsaved-value mapping was incorrect) : [ltass.staudy.spring.data.jpa.entity.User#1]"}}
33
+
34
+10. update 唯一索引冲突
35
+{"ex":{"exClass":"org.springframework.dao.DataIntegrityViolationException","message":"could not execute statement; SQL [n/a]; constraint [PRIMARY]; nested exception is org.hibernate.exception.ConstraintViolationException: could not execute statement"},"exCause":{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}}

+ 18
- 0
ddl.txt Просмотреть файл

@@ -0,0 +1,18 @@
1
+CREATE TABLE `users` (
2
+  `id` bigint(20) NOT NULL COMMENT '主键',
3
+  `nick_name` varchar(20) DEFAULT NULL COMMENT 'NickName',
4
+  `name` varchar(50) DEFAULT NULL COMMENT '名前',
5
+  `email` varchar(200) DEFAULT NULL COMMENT 'メール',
6
+  `del_flag` tinyint(4) NOT NULL COMMENT '删除标识',
7
+  `ver_no` bigint(20) DEFAULT NULL COMMENT '版本',
8
+  `register_datetime` varchar(20) NOT NULL COMMENT '登録日時文字列',
9
+  `register_user_id` bigint(20) NOT NULL COMMENT '登録ユーザ',
10
+  `register_process` varchar(20) NOT NULL COMMENT '登録プロセス',
11
+  `update_datetime` varchar(20) NOT NULL COMMENT '更新日時文字列',
12
+  `update_user_id` bigint(20) NOT NULL COMMENT '更新ユーザ',
13
+  `update_process` varchar(20) NOT NULL COMMENT '更新プロセス',
14
+  PRIMARY KEY (`id`),
15
+  UNIQUE KEY `idx_email` (`email`),
16
+  KEY `idx_register_datetime` (`register_datetime`),
17
+  KEY `idx_update_datetime` (`update_datetime`)
18
+) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户信息';

+ 286
- 0
mvnw Просмотреть файл

@@ -0,0 +1,286 @@
1
+#!/bin/sh
2
+# ----------------------------------------------------------------------------
3
+# Licensed to the Apache Software Foundation (ASF) under one
4
+# or more contributor license agreements.  See the NOTICE file
5
+# distributed with this work for additional information
6
+# regarding copyright ownership.  The ASF licenses this file
7
+# to you under the Apache License, Version 2.0 (the
8
+# "License"); you may not use this file except in compliance
9
+# with the License.  You may obtain a copy of the License at
10
+#
11
+#    http://www.apache.org/licenses/LICENSE-2.0
12
+#
13
+# Unless required by applicable law or agreed to in writing,
14
+# software distributed under the License is distributed on an
15
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
16
+# KIND, either express or implied.  See the License for the
17
+# specific language governing permissions and limitations
18
+# under the License.
19
+# ----------------------------------------------------------------------------
20
+
21
+# ----------------------------------------------------------------------------
22
+# Maven2 Start Up Batch script
23
+#
24
+# Required ENV vars:
25
+# ------------------
26
+#   JAVA_HOME - location of a JDK home dir
27
+#
28
+# Optional ENV vars
29
+# -----------------
30
+#   M2_HOME - location of maven2's installed home dir
31
+#   MAVEN_OPTS - parameters passed to the Java VM when running Maven
32
+#     e.g. to debug Maven itself, use
33
+#       set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
34
+#   MAVEN_SKIP_RC - flag to disable loading of mavenrc files
35
+# ----------------------------------------------------------------------------
36
+
37
+if [ -z "$MAVEN_SKIP_RC" ] ; then
38
+
39
+  if [ -f /etc/mavenrc ] ; then
40
+    . /etc/mavenrc
41
+  fi
42
+
43
+  if [ -f "$HOME/.mavenrc" ] ; then
44
+    . "$HOME/.mavenrc"
45
+  fi
46
+
47
+fi
48
+
49
+# OS specific support.  $var _must_ be set to either true or false.
50
+cygwin=false;
51
+darwin=false;
52
+mingw=false
53
+case "`uname`" in
54
+  CYGWIN*) cygwin=true ;;
55
+  MINGW*) mingw=true;;
56
+  Darwin*) darwin=true
57
+    # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
58
+    # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
59
+    if [ -z "$JAVA_HOME" ]; then
60
+      if [ -x "/usr/libexec/java_home" ]; then
61
+        export JAVA_HOME="`/usr/libexec/java_home`"
62
+      else
63
+        export JAVA_HOME="/Library/Java/Home"
64
+      fi
65
+    fi
66
+    ;;
67
+esac
68
+
69
+if [ -z "$JAVA_HOME" ] ; then
70
+  if [ -r /etc/gentoo-release ] ; then
71
+    JAVA_HOME=`java-config --jre-home`
72
+  fi
73
+fi
74
+
75
+if [ -z "$M2_HOME" ] ; then
76
+  ## resolve links - $0 may be a link to maven's home
77
+  PRG="$0"
78
+
79
+  # need this for relative symlinks
80
+  while [ -h "$PRG" ] ; do
81
+    ls=`ls -ld "$PRG"`
82
+    link=`expr "$ls" : '.*-> \(.*\)$'`
83
+    if expr "$link" : '/.*' > /dev/null; then
84
+      PRG="$link"
85
+    else
86
+      PRG="`dirname "$PRG"`/$link"
87
+    fi
88
+  done
89
+
90
+  saveddir=`pwd`
91
+
92
+  M2_HOME=`dirname "$PRG"`/..
93
+
94
+  # make it fully qualified
95
+  M2_HOME=`cd "$M2_HOME" && pwd`
96
+
97
+  cd "$saveddir"
98
+  # echo Using m2 at $M2_HOME
99
+fi
100
+
101
+# For Cygwin, ensure paths are in UNIX format before anything is touched
102
+if $cygwin ; then
103
+  [ -n "$M2_HOME" ] &&
104
+    M2_HOME=`cygpath --unix "$M2_HOME"`
105
+  [ -n "$JAVA_HOME" ] &&
106
+    JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
107
+  [ -n "$CLASSPATH" ] &&
108
+    CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
109
+fi
110
+
111
+# For Mingw, ensure paths are in UNIX format before anything is touched
112
+if $mingw ; then
113
+  [ -n "$M2_HOME" ] &&
114
+    M2_HOME="`(cd "$M2_HOME"; pwd)`"
115
+  [ -n "$JAVA_HOME" ] &&
116
+    JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
117
+  # TODO classpath?
118
+fi
119
+
120
+if [ -z "$JAVA_HOME" ]; then
121
+  javaExecutable="`which javac`"
122
+  if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
123
+    # readlink(1) is not available as standard on Solaris 10.
124
+    readLink=`which readlink`
125
+    if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
126
+      if $darwin ; then
127
+        javaHome="`dirname \"$javaExecutable\"`"
128
+        javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
129
+      else
130
+        javaExecutable="`readlink -f \"$javaExecutable\"`"
131
+      fi
132
+      javaHome="`dirname \"$javaExecutable\"`"
133
+      javaHome=`expr "$javaHome" : '\(.*\)/bin'`
134
+      JAVA_HOME="$javaHome"
135
+      export JAVA_HOME
136
+    fi
137
+  fi
138
+fi
139
+
140
+if [ -z "$JAVACMD" ] ; then
141
+  if [ -n "$JAVA_HOME"  ] ; then
142
+    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
143
+      # IBM's JDK on AIX uses strange locations for the executables
144
+      JAVACMD="$JAVA_HOME/jre/sh/java"
145
+    else
146
+      JAVACMD="$JAVA_HOME/bin/java"
147
+    fi
148
+  else
149
+    JAVACMD="`which java`"
150
+  fi
151
+fi
152
+
153
+if [ ! -x "$JAVACMD" ] ; then
154
+  echo "Error: JAVA_HOME is not defined correctly." >&2
155
+  echo "  We cannot execute $JAVACMD" >&2
156
+  exit 1
157
+fi
158
+
159
+if [ -z "$JAVA_HOME" ] ; then
160
+  echo "Warning: JAVA_HOME environment variable is not set."
161
+fi
162
+
163
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
164
+
165
+# traverses directory structure from process work directory to filesystem root
166
+# first directory with .mvn subdirectory is considered project base directory
167
+find_maven_basedir() {
168
+
169
+  if [ -z "$1" ]
170
+  then
171
+    echo "Path not specified to find_maven_basedir"
172
+    return 1
173
+  fi
174
+
175
+  basedir="$1"
176
+  wdir="$1"
177
+  while [ "$wdir" != '/' ] ; do
178
+    if [ -d "$wdir"/.mvn ] ; then
179
+      basedir=$wdir
180
+      break
181
+    fi
182
+    # workaround for JBEAP-8937 (on Solaris 10/Sparc)
183
+    if [ -d "${wdir}" ]; then
184
+      wdir=`cd "$wdir/.."; pwd`
185
+    fi
186
+    # end of workaround
187
+  done
188
+  echo "${basedir}"
189
+}
190
+
191
+# concatenates all lines of a file
192
+concat_lines() {
193
+  if [ -f "$1" ]; then
194
+    echo "$(tr -s '\n' ' ' < "$1")"
195
+  fi
196
+}
197
+
198
+BASE_DIR=`find_maven_basedir "$(pwd)"`
199
+if [ -z "$BASE_DIR" ]; then
200
+  exit 1;
201
+fi
202
+
203
+##########################################################################################
204
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
205
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
206
+##########################################################################################
207
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
208
+    if [ "$MVNW_VERBOSE" = true ]; then
209
+      echo "Found .mvn/wrapper/maven-wrapper.jar"
210
+    fi
211
+else
212
+    if [ "$MVNW_VERBOSE" = true ]; then
213
+      echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
214
+    fi
215
+    jarUrl="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.4.2/maven-wrapper-0.4.2.jar"
216
+    while IFS="=" read key value; do
217
+      case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
218
+      esac
219
+    done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
220
+    if [ "$MVNW_VERBOSE" = true ]; then
221
+      echo "Downloading from: $jarUrl"
222
+    fi
223
+    wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
224
+
225
+    if command -v wget > /dev/null; then
226
+        if [ "$MVNW_VERBOSE" = true ]; then
227
+          echo "Found wget ... using wget"
228
+        fi
229
+        wget "$jarUrl" -O "$wrapperJarPath"
230
+    elif command -v curl > /dev/null; then
231
+        if [ "$MVNW_VERBOSE" = true ]; then
232
+          echo "Found curl ... using curl"
233
+        fi
234
+        curl -o "$wrapperJarPath" "$jarUrl"
235
+    else
236
+        if [ "$MVNW_VERBOSE" = true ]; then
237
+          echo "Falling back to using Java to download"
238
+        fi
239
+        javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
240
+        if [ -e "$javaClass" ]; then
241
+            if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
242
+                if [ "$MVNW_VERBOSE" = true ]; then
243
+                  echo " - Compiling MavenWrapperDownloader.java ..."
244
+                fi
245
+                # Compiling the Java class
246
+                ("$JAVA_HOME/bin/javac" "$javaClass")
247
+            fi
248
+            if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
249
+                # Running the downloader
250
+                if [ "$MVNW_VERBOSE" = true ]; then
251
+                  echo " - Running MavenWrapperDownloader.java ..."
252
+                fi
253
+                ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
254
+            fi
255
+        fi
256
+    fi
257
+fi
258
+##########################################################################################
259
+# End of extension
260
+##########################################################################################
261
+
262
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
263
+if [ "$MVNW_VERBOSE" = true ]; then
264
+  echo $MAVEN_PROJECTBASEDIR
265
+fi
266
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
267
+
268
+# For Cygwin, switch paths to Windows format before running java
269
+if $cygwin; then
270
+  [ -n "$M2_HOME" ] &&
271
+    M2_HOME=`cygpath --path --windows "$M2_HOME"`
272
+  [ -n "$JAVA_HOME" ] &&
273
+    JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
274
+  [ -n "$CLASSPATH" ] &&
275
+    CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
276
+  [ -n "$MAVEN_PROJECTBASEDIR" ] &&
277
+    MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
278
+fi
279
+
280
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
281
+
282
+exec "$JAVACMD" \
283
+  $MAVEN_OPTS \
284
+  -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
285
+  "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
286
+  ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"

+ 161
- 0
mvnw.cmd Просмотреть файл

@@ -0,0 +1,161 @@
1
+@REM ----------------------------------------------------------------------------
2
+@REM Licensed to the Apache Software Foundation (ASF) under one
3
+@REM or more contributor license agreements.  See the NOTICE file
4
+@REM distributed with this work for additional information
5
+@REM regarding copyright ownership.  The ASF licenses this file
6
+@REM to you under the Apache License, Version 2.0 (the
7
+@REM "License"); you may not use this file except in compliance
8
+@REM with the License.  You may obtain a copy of the License at
9
+@REM
10
+@REM    http://www.apache.org/licenses/LICENSE-2.0
11
+@REM
12
+@REM Unless required by applicable law or agreed to in writing,
13
+@REM software distributed under the License is distributed on an
14
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
15
+@REM KIND, either express or implied.  See the License for the
16
+@REM specific language governing permissions and limitations
17
+@REM under the License.
18
+@REM ----------------------------------------------------------------------------
19
+
20
+@REM ----------------------------------------------------------------------------
21
+@REM Maven2 Start Up Batch script
22
+@REM
23
+@REM Required ENV vars:
24
+@REM JAVA_HOME - location of a JDK home dir
25
+@REM
26
+@REM Optional ENV vars
27
+@REM M2_HOME - location of maven2's installed home dir
28
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
29
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a key stroke before ending
30
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
31
+@REM     e.g. to debug Maven itself, use
32
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
33
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
34
+@REM ----------------------------------------------------------------------------
35
+
36
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
37
+@echo off
38
+@REM set title of command window
39
+title %0
40
+@REM enable echoing my setting MAVEN_BATCH_ECHO to 'on'
41
+@if "%MAVEN_BATCH_ECHO%" == "on"  echo %MAVEN_BATCH_ECHO%
42
+
43
+@REM set %HOME% to equivalent of $HOME
44
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
45
+
46
+@REM Execute a user defined script before this one
47
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
48
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
49
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
50
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
51
+:skipRcPre
52
+
53
+@setlocal
54
+
55
+set ERROR_CODE=0
56
+
57
+@REM To isolate internal variables from possible post scripts, we use another setlocal
58
+@setlocal
59
+
60
+@REM ==== START VALIDATION ====
61
+if not "%JAVA_HOME%" == "" goto OkJHome
62
+
63
+echo.
64
+echo Error: JAVA_HOME not found in your environment. >&2
65
+echo Please set the JAVA_HOME variable in your environment to match the >&2
66
+echo location of your Java installation. >&2
67
+echo.
68
+goto error
69
+
70
+:OkJHome
71
+if exist "%JAVA_HOME%\bin\java.exe" goto init
72
+
73
+echo.
74
+echo Error: JAVA_HOME is set to an invalid directory. >&2
75
+echo JAVA_HOME = "%JAVA_HOME%" >&2
76
+echo Please set the JAVA_HOME variable in your environment to match the >&2
77
+echo location of your Java installation. >&2
78
+echo.
79
+goto error
80
+
81
+@REM ==== END VALIDATION ====
82
+
83
+:init
84
+
85
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
86
+@REM Fallback to current working directory if not found.
87
+
88
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
89
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
90
+
91
+set EXEC_DIR=%CD%
92
+set WDIR=%EXEC_DIR%
93
+:findBaseDir
94
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
95
+cd ..
96
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
97
+set WDIR=%CD%
98
+goto findBaseDir
99
+
100
+:baseDirFound
101
+set MAVEN_PROJECTBASEDIR=%WDIR%
102
+cd "%EXEC_DIR%"
103
+goto endDetectBaseDir
104
+
105
+:baseDirNotFound
106
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
107
+cd "%EXEC_DIR%"
108
+
109
+:endDetectBaseDir
110
+
111
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
112
+
113
+@setlocal EnableExtensions EnableDelayedExpansion
114
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
115
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
116
+
117
+:endReadAdditionalConfig
118
+
119
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
120
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
121
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
122
+
123
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.4.2/maven-wrapper-0.4.2.jar"
124
+FOR /F "tokens=1,2 delims==" %%A IN (%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties) DO (
125
+	IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B 
126
+)
127
+
128
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
129
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
130
+if exist %WRAPPER_JAR% (
131
+    echo Found %WRAPPER_JAR%
132
+) else (
133
+    echo Couldn't find %WRAPPER_JAR%, downloading it ...
134
+	echo Downloading from: %DOWNLOAD_URL%
135
+    powershell -Command "(New-Object Net.WebClient).DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"
136
+    echo Finished downloading %WRAPPER_JAR%
137
+)
138
+@REM End of extension
139
+
140
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
141
+if ERRORLEVEL 1 goto error
142
+goto end
143
+
144
+:error
145
+set ERROR_CODE=1
146
+
147
+:end
148
+@endlocal & set ERROR_CODE=%ERROR_CODE%
149
+
150
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
151
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
152
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
153
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
154
+:skipRcPost
155
+
156
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
157
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
158
+
159
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
160
+
161
+exit /B %ERROR_CODE%

+ 75
- 0
pom.xml Просмотреть файл

@@ -0,0 +1,75 @@
1
+<?xml version="1.0" encoding="UTF-8"?>
2
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
3
+	xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
4
+	<modelVersion>4.0.0</modelVersion>
5
+	<parent>
6
+		<groupId>org.springframework.boot</groupId>
7
+		<artifactId>spring-boot-starter-parent</artifactId>
8
+		<version>2.1.2.RELEASE</version>
9
+		<relativePath/> <!-- lookup parent from repository -->
10
+	</parent>
11
+	<groupId>ltass.staudy</groupId>
12
+	<artifactId>spring-data-jpa</artifactId>
13
+	<version>0.0.1-SNAPSHOT</version>
14
+	<name>spring-data-jpa</name>
15
+	<description>Demo project for Spring Boot</description>
16
+
17
+	<properties>
18
+		<java.version>1.8</java.version>
19
+	</properties>
20
+
21
+	<dependencies>
22
+		<dependency>
23
+			<groupId>org.springframework.boot</groupId>
24
+			<artifactId>spring-boot-starter-data-jpa</artifactId>
25
+		</dependency>
26
+		<dependency>
27
+			<groupId>org.springframework.boot</groupId>
28
+			<artifactId>spring-boot-starter-web</artifactId>
29
+		</dependency>
30
+
31
+		<dependency>
32
+			<groupId>org.springframework.boot</groupId>
33
+			<artifactId>spring-boot-devtools</artifactId>
34
+			<scope>runtime</scope>
35
+		</dependency>
36
+		<dependency>
37
+			<groupId>mysql</groupId>
38
+			<artifactId>mysql-connector-java</artifactId>
39
+			<scope>runtime</scope>
40
+		</dependency>
41
+		<dependency>
42
+			<groupId>cn.hutool</groupId>
43
+			<artifactId>hutool-all</artifactId>
44
+			<version>4.4.3</version>
45
+		</dependency>
46
+		<!-- https://mvnrepository.com/artifact/org.projectlombok/lombok -->
47
+		<dependency>
48
+			<groupId>org.projectlombok</groupId>
49
+			<artifactId>lombok</artifactId>
50
+			<version>1.18.4</version>
51
+			<scope>provided</scope>
52
+		</dependency>
53
+		<!-- https://mvnrepository.com/artifact/com.alibaba/fastjson -->
54
+		<dependency>
55
+			<groupId>com.alibaba</groupId>
56
+			<artifactId>fastjson</artifactId>
57
+			<version>1.2.56</version>
58
+		</dependency>
59
+		<dependency>
60
+			<groupId>org.springframework.boot</groupId>
61
+			<artifactId>spring-boot-starter-test</artifactId>
62
+			<scope>test</scope>
63
+		</dependency>
64
+	</dependencies>
65
+
66
+	<build>
67
+		<plugins>
68
+			<plugin>
69
+				<groupId>org.springframework.boot</groupId>
70
+				<artifactId>spring-boot-maven-plugin</artifactId>
71
+			</plugin>
72
+		</plugins>
73
+	</build>
74
+
75
+</project>

+ 14
- 0
src/main/java/ltass/staudy/spring/data/jpa/SpringDataJpaApplication.java Просмотреть файл

@@ -0,0 +1,14 @@
1
+package ltass.staudy.spring.data.jpa;
2
+
3
+import org.springframework.boot.SpringApplication;
4
+import org.springframework.boot.autoconfigure.SpringBootApplication;
5
+
6
+@SpringBootApplication
7
+public class SpringDataJpaApplication {
8
+
9
+	public static void main(String[] args) {
10
+		SpringApplication.run(SpringDataJpaApplication.class, args);
11
+	}
12
+
13
+}
14
+

+ 324
- 0
src/main/java/ltass/staudy/spring/data/jpa/controller/TestController.java Просмотреть файл

@@ -0,0 +1,324 @@
1
+package ltass.staudy.spring.data.jpa.controller;
2
+
3
+import com.alibaba.fastjson.JSON;
4
+import ltass.staudy.spring.data.jpa.dao.UserJpaDao;
5
+import ltass.staudy.spring.data.jpa.entity.User;
6
+import ltass.staudy.spring.data.jpa.repo.UserRepository;
7
+import org.springframework.beans.factory.annotation.Autowired;
8
+import org.springframework.web.bind.annotation.GetMapping;
9
+import org.springframework.web.bind.annotation.RestController;
10
+
11
+import java.util.LinkedHashMap;
12
+import java.util.List;
13
+import java.util.Map;
14
+
15
+@RestController
16
+public class TestController {
17
+    @Autowired
18
+    UserRepository userRepository;
19
+    @Autowired
20
+    UserJpaDao userJpaDao;
21
+
22
+    @GetMapping("/user/delete/all")
23
+    public String deleteAll(){
24
+        List<User> userList = userRepository.findAll();
25
+        for(User item : userList){
26
+            userJpaDao.deleteById(item.getId());
27
+        }
28
+        return "OK.";
29
+    }
30
+
31
+    @GetMapping("/user/insert/error/pri_key_null")
32
+    public String insertErrorPriKeyNull(){
33
+        User user = new User();
34
+        user.setName("my name");
35
+        try{
36
+            userJpaDao.insert(user);
37
+        }catch (Exception ex){
38
+            return dealException(ex);
39
+        }
40
+        return "OK.";
41
+    }
42
+
43
+    //{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}
44
+    @GetMapping("/user/insert/error/column_not_null")
45
+    public String insertErrorNotNull(){
46
+        User user = new User();
47
+        user.setId(1L);
48
+        user.setName("my name");
49
+        try{
50
+            userJpaDao.insert(user);
51
+        }catch (Exception ex){
52
+            return dealException(ex);
53
+        }
54
+        return "OK.";
55
+    }
56
+
57
+    //{"causeBy":"org.hibernate.exception.DataException","message":"could not execute statement"}
58
+    @GetMapping("/user/insert/error/over_size")
59
+    public String insertErrorOverSize() {
60
+        User user = new User();
61
+        user.setId(1L);
62
+        user.setNickName("123456789012345678901");
63
+        user.setName("myName");
64
+        user.setEmail("email");
65
+        user.setDelFlag(0);
66
+        user.setRegisterDatetime("2019/01/01 01:01:00");
67
+        user.setRegisterUserId(1L);
68
+        user.setRegisterProcess("web");
69
+        user.setUpdateDatetime("2019/01/01 01:01:00");
70
+        user.setUpdateUserId(1L);
71
+        user.setUpdateProcess("web");
72
+        try{
73
+            userJpaDao.insert(user);
74
+        }catch (Exception ex){
75
+            return dealException(ex);
76
+        }
77
+        return "OK.";
78
+    }
79
+
80
+    @GetMapping("/user/insert/success")
81
+    public String insertSuccess() {
82
+        User user = new User();
83
+        user.setId(1L);
84
+        user.setNickName("nickName");
85
+        user.setName("myName");
86
+        user.setEmail("email");
87
+        user.setDelFlag(0);
88
+        user.setRegisterDatetime("2019/01/01 01:01:00");
89
+        user.setRegisterUserId(1L);
90
+        user.setRegisterProcess("web");
91
+        user.setUpdateDatetime("2019/01/01 01:01:00");
92
+        user.setUpdateUserId(1L);
93
+        user.setUpdateProcess("web");
94
+
95
+        User retUser1 = userJpaDao.insert(user);
96
+
97
+        User user2 = new User();
98
+        user2.setId(2L);
99
+        user2.setNickName("nickName2");
100
+        user2.setName("myName2");
101
+        user2.setEmail("email2");
102
+        user2.setDelFlag(0);
103
+        user2.setRegisterDatetime("2019/01/01 01:01:00");
104
+        user2.setRegisterUserId(1L);
105
+        user2.setRegisterProcess("web");
106
+        user2.setUpdateDatetime("2019/01/01 01:01:00");
107
+        user2.setUpdateUserId(1L);
108
+        user2.setUpdateProcess("web");
109
+        User retUser2 = userJpaDao.insert(user2);
110
+
111
+        Map<String,User> retMap = new LinkedHashMap<>();
112
+        retMap.put("user1",retUser1);
113
+        retMap.put("user2",retUser2);
114
+
115
+        return JSON.toJSONString(retMap);
116
+    }
117
+
118
+    //{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}
119
+    @GetMapping("/user/insert/error/conflict_pri_key")
120
+    public String insertErrorConflictPriKey() {
121
+        User user = new User();
122
+        user.setId(1L);
123
+        user.setNickName("nickName");
124
+        user.setName("myName");
125
+        user.setEmail("email");
126
+        user.setDelFlag(0);
127
+        user.setRegisterDatetime("2019/01/01 01:01:00");
128
+        user.setRegisterUserId(1L);
129
+        user.setRegisterProcess("web");
130
+        user.setUpdateDatetime("2019/01/01 01:01:00");
131
+        user.setUpdateUserId(1L);
132
+        user.setUpdateProcess("web");
133
+
134
+        try{
135
+            userJpaDao.insert(user);
136
+        }catch (Exception ex){
137
+            return dealException(ex);
138
+        }
139
+        return "OK.";
140
+    }
141
+
142
+    //{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}
143
+    @GetMapping("/user/insert/error/conflict_unique")
144
+    public String insertErrorConflictUnique() {
145
+        User user = new User();
146
+        user.setId(1L);
147
+        user.setNickName("nickName");
148
+        user.setName("myName");
149
+        user.setEmail("email");
150
+        user.setDelFlag(0);
151
+        user.setRegisterDatetime("2019/01/01 01:01:00");
152
+        user.setRegisterUserId(1L);
153
+        user.setRegisterProcess("web");
154
+        user.setUpdateDatetime("2019/01/01 01:01:00");
155
+        user.setUpdateUserId(1L);
156
+        user.setUpdateProcess("web");
157
+
158
+        try{
159
+            userJpaDao.insert(user);
160
+        }catch (Exception ex){
161
+            return dealException(ex);
162
+        }
163
+        return "OK.";
164
+    }
165
+
166
+    //{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}
167
+    @GetMapping("/user/update/error/conflict_unique")
168
+    public String updateErrorConflictUnique() {
169
+        User user = new User();
170
+        user.setId(1L);
171
+        user.setNickName("nickName");
172
+        user.setName("myName");
173
+        user.setEmail("email2");
174
+        user.setDelFlag(0);
175
+        user.setRegisterDatetime("2019/01/01 01:01:00");
176
+        user.setRegisterUserId(1L);
177
+        user.setRegisterProcess("web");
178
+        user.setUpdateDatetime("2019/01/01 01:01:00");
179
+        user.setUpdateUserId(1L);
180
+        user.setUpdateProcess("web");
181
+
182
+        try{
183
+            userJpaDao.update(user);
184
+        }catch (Exception ex){
185
+            return dealException(ex);
186
+        }
187
+        return "OK.";
188
+    }
189
+
190
+    //{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}
191
+    @GetMapping("/user/update/error/version")
192
+    public String updateErrorVersion() {
193
+        User user = new User();
194
+        user.setId(1L);
195
+        user.setNickName("nickName");
196
+        user.setName("myName");
197
+        user.setEmail("email");
198
+        user.setDelFlag(0);
199
+        user.setVerNo(100);
200
+        user.setRegisterDatetime("2019/01/01 01:01:00");
201
+        user.setRegisterUserId(1L);
202
+        user.setRegisterProcess("web");
203
+        user.setUpdateDatetime("2019/01/01 01:01:00");
204
+        user.setUpdateUserId(1L);
205
+        user.setUpdateProcess("web");
206
+
207
+        try{
208
+            userJpaDao.update(user);
209
+        }catch (Exception ex){
210
+            return dealException(ex);
211
+        }
212
+        return "OK.";
213
+    }
214
+
215
+    //{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}
216
+    @GetMapping("/user/update/error/over_size")
217
+    public String updateErrorOverSize() {
218
+        User user = new User();
219
+        user.setId(1L);
220
+        user.setNickName("123456789012345678901");
221
+        user.setName("myName");
222
+        user.setEmail("email");
223
+        user.setDelFlag(0);
224
+        user.setRegisterDatetime("2019/01/01 01:01:00");
225
+        user.setRegisterUserId(1L);
226
+        user.setRegisterProcess("web");
227
+        user.setUpdateDatetime("2019/01/01 01:01:00");
228
+        user.setUpdateUserId(1L);
229
+        user.setUpdateProcess("web");
230
+
231
+        try{
232
+            userJpaDao.update(user);
233
+        }catch (Exception ex){
234
+            return dealException(ex);
235
+        }
236
+        return "OK.";
237
+    }
238
+
239
+    //{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}
240
+    @GetMapping("/user/update/error/null")
241
+    public String updateErrorOverSizeNull() {
242
+        User user = new User();
243
+        user.setId(1L);
244
+        user.setNickName("12345");
245
+        user.setName("myName");
246
+        user.setEmail("email");
247
+        user.setRegisterDatetime("2019/01/01 01:01:00");
248
+        user.setRegisterUserId(1L);
249
+        user.setRegisterProcess("web");
250
+        user.setUpdateDatetime("2019/01/01 01:01:00");
251
+        user.setUpdateUserId(1L);
252
+        user.setUpdateProcess("web");
253
+
254
+        try{
255
+            userJpaDao.update(user);
256
+        }catch (Exception ex){
257
+            return dealException(ex);
258
+        }
259
+        return "OK.";
260
+    }
261
+
262
+    //{"causeBy":"org.hibernate.exception.ConstraintViolationException","message":"could not execute statement"}
263
+    @GetMapping("/user/update/error/pri_key_null")
264
+    public String updateErrorPriKeyNull() {
265
+        User user = new User();
266
+        user.setNickName("12345");
267
+        user.setName("myName");
268
+        user.setEmail("email");
269
+        user.setRegisterDatetime("2019/01/01 01:01:00");
270
+        user.setRegisterUserId(1L);
271
+        user.setRegisterProcess("web");
272
+        user.setUpdateDatetime("2019/01/01 01:01:00");
273
+        user.setUpdateUserId(1L);
274
+        user.setUpdateProcess("web");
275
+
276
+        try{
277
+            userJpaDao.update(user);
278
+        }catch (Exception ex){
279
+            return dealException(ex);
280
+        }
281
+        return "OK.";
282
+    }
283
+
284
+    @GetMapping("/user/delete/error/no_data")
285
+    public String deleteNoData() {
286
+
287
+        try{
288
+            userJpaDao.deleteById(8L);
289
+        }catch (Exception ex){
290
+            return dealException(ex);
291
+        }
292
+        return "OK.";
293
+    }
294
+
295
+    @GetMapping("/user/delete/success")
296
+    public String deleteSuccess() {
297
+
298
+        try{
299
+            userJpaDao.deleteById(1L);
300
+        }catch (Exception ex){
301
+            return dealException(ex);
302
+        }
303
+        return "OK.";
304
+    }
305
+
306
+    private String dealException(Exception ex){
307
+        Map<String,Map<String,Object>> retMap = new LinkedHashMap<>();
308
+
309
+        Map<String,Object> retValue1 = new LinkedHashMap<>();
310
+        retValue1.put("exClass",ex.getClass());
311
+        retValue1.put("message",ex.getMessage());
312
+
313
+        retMap.put("ex",retValue1);
314
+
315
+        Map<String,Object> retValue2 = new LinkedHashMap<>();
316
+        retValue2.put("causeBy",ex.getCause().getClass());
317
+        retValue2.put("message",ex.getCause().getMessage());
318
+
319
+        retMap.put("exCause",retValue2);
320
+
321
+        return JSON.toJSONString(retMap);
322
+    }
323
+
324
+}

+ 16
- 0
src/main/java/ltass/staudy/spring/data/jpa/dao/UserJpaDao.java Просмотреть файл

@@ -0,0 +1,16 @@
1
+package ltass.staudy.spring.data.jpa.dao;
2
+
3
+
4
+import ltass.staudy.spring.data.jpa.entity.User;
5
+
6
+public interface UserJpaDao {
7
+
8
+    User insert(User entity);
9
+
10
+    User update(User entity);
11
+
12
+    User findById(Long id);
13
+
14
+    User deleteById(Long id);
15
+
16
+}

+ 37
- 0
src/main/java/ltass/staudy/spring/data/jpa/dao/impl/UserJpaDaoImpl.java Просмотреть файл

@@ -0,0 +1,37 @@
1
+package ltass.staudy.spring.data.jpa.dao.impl;
2
+
3
+import ltass.staudy.spring.data.jpa.dao.UserJpaDao;
4
+import ltass.staudy.spring.data.jpa.entity.User;
5
+import ltass.staudy.spring.data.jpa.repo.UserRepository;
6
+import org.springframework.beans.factory.annotation.Autowired;
7
+import org.springframework.stereotype.Service;
8
+
9
+@Service
10
+public class UserJpaDaoImpl implements UserJpaDao {
11
+    @Autowired
12
+    UserRepository repository;
13
+
14
+    @Override
15
+    public User insert(User entity) {
16
+        return repository.save(entity);
17
+    }
18
+
19
+    @Override
20
+    public User update(User entity) {
21
+        return repository.save(entity);
22
+    }
23
+
24
+    @Override
25
+    public User findById(Long id) {
26
+        return repository.findById(id).orElse(null);
27
+    }
28
+
29
+    @Override
30
+    public User deleteById(Long id) {
31
+        User deletedEntity = findById(id);
32
+        if(deletedEntity!=null){
33
+            repository.deleteById(id);
34
+        }
35
+        return deletedEntity;
36
+    }
37
+}

+ 42
- 0
src/main/java/ltass/staudy/spring/data/jpa/entity/User.java Просмотреть файл

@@ -0,0 +1,42 @@
1
+package ltass.staudy.spring.data.jpa.entity;
2
+
3
+import lombok.Getter;
4
+import lombok.Setter;
5
+
6
+import javax.persistence.Entity;
7
+import javax.persistence.Id;
8
+import javax.persistence.Table;
9
+import javax.persistence.Version;
10
+
11
+@Entity
12
+@Getter
13
+@Setter
14
+@Table(name ="users")
15
+public class User {
16
+    @Id
17
+    private Long id;
18
+
19
+    private String nickName;
20
+
21
+    private String name;
22
+
23
+    private String email;
24
+
25
+    private Integer delFlag;
26
+
27
+    @Version
28
+    private Integer verNo;
29
+
30
+    private String registerDatetime;
31
+
32
+    private Long registerUserId;
33
+
34
+    private String registerProcess;
35
+
36
+    private String updateDatetime;
37
+
38
+    private Long updateUserId;
39
+
40
+    private String updateProcess;
41
+
42
+}

+ 9
- 0
src/main/java/ltass/staudy/spring/data/jpa/repo/UserRepository.java Просмотреть файл

@@ -0,0 +1,9 @@
1
+package ltass.staudy.spring.data.jpa.repo;
2
+
3
+import ltass.staudy.spring.data.jpa.entity.User;
4
+import org.springframework.data.jpa.repository.JpaRepository;
5
+import org.springframework.stereotype.Repository;
6
+
7
+@Repository
8
+public interface UserRepository extends JpaRepository<User,Long> {
9
+}

+ 12
- 0
src/main/java/ltass/staudy/spring/data/jpa/utils/IdUtils.java Просмотреть файл

@@ -0,0 +1,12 @@
1
+package ltass.staudy.spring.data.jpa.utils;
2
+
3
+import cn.hutool.core.lang.Snowflake;
4
+
5
+public class IdUtils {
6
+
7
+    public final static Snowflake sf = new Snowflake(1,1);
8
+
9
+    public static long id(){
10
+        return sf.nextId();
11
+    }
12
+}

+ 11
- 0
src/main/resources/application.properties Просмотреть файл

@@ -0,0 +1,11 @@
1
+#mysql
2
+spring.datasource.url=jdbc:mysql://localhost:3306/jpademo?useUnicode=yes&characterEncoding=UTF-8&serverTimezone=JST
3
+spring.datasource.username=root
4
+spring.datasource.password=develop
5
+spring.datasource.driverClassName=com.mysql.jdbc.Driver
6
+spring.datasource.test-on-return: true
7
+spring.datasource.validation-query: "select 1"
8
+
9
+#jpa
10
+spring.jpa.show-sql=true
11
+spring.jpa.database=MYSQL

+ 17
- 0
src/test/java/ltass/staudy/springdatajpa/SpringDataJpaApplicationTests.java Просмотреть файл

@@ -0,0 +1,17 @@
1
+package ltass.staudy.springdatajpa;
2
+
3
+import org.junit.Test;
4
+import org.junit.runner.RunWith;
5
+import org.springframework.boot.test.context.SpringBootTest;
6
+import org.springframework.test.context.junit4.SpringRunner;
7
+
8
+@RunWith(SpringRunner.class)
9
+@SpringBootTest
10
+public class SpringDataJpaApplicationTests {
11
+
12
+	@Test
13
+	public void contextLoads() {
14
+	}
15
+
16
+}
17
+

Загрузка…
Отмена
Сохранить